<?php
namespace vimmaniac\logging;

define('VMNC_LOG_LEVEL_ERROR', 0);
define('VMNC_LOG_LEVEL_WARN', 1);
define('VMNC_LOG_LEVEL_INFO', 2);
define('VMNC_LOG_LEVEL_DEBUG', 3);

$VMNC_LOG_extra = 1;

class CreateLogger {
    public $log_prefix;
    public $log_device;
    public $log_level;

    public function
    __construct(
        $log_prefix,
        $log_device=STDOUT,
        $log_level=VMNC_LOG_LEVEL_INFO
    ){
        $this->log_prefix = $log_prefix;
        $this->log_device = $log_device;
        $this->log_level = $log_level;
    }

    public function
    add($msg, $lvl){
        if ($lvl > $this->log_level) return;

        switch($lvl){
            case VMNC_LOG_LEVEL_ERROR:
                $lvl_name = 'ERROR'; break;
            case VMNC_LOG_LEVEL_WARN:
                $lvl_name = 'WARN'; break;
            case VMNC_LOG_LEVEL_INFO:
                $lvl_name = 'INFO'; break;
            case VMNC_LOG_LEVEL_DEBUG:
                $lvl_name = 'DEBUG'; break;
            default:
                $lvl_name = '?'; break;
        }

        fprintf(
            $this->log_device,
            "|%s|%s|%s|%s| %s".PHP_EOL,
            $this->log_prefix,
            $lvl_name,
            gmdate('Y-m-d H:i:s'),
            getmypid(),
            $msg
        ); 
    }
}
